-- ==========================
-- Magic Maze - www.atien.net
-- Fonctions pour l'IA
-- ==========================

function AIcase()
	-- scan de toutes les possibilitees
	local way = brain()

	local xNew = 0
	local yNew = 0
	local rNew = 0

	xNew, yNew, rNew = convertPosition(way)

	-- Positionnement de la case libre
	while true do
		if lcase.x == xNew and lcase.y == yNew then
			break
		else
			moveCase(1)
			shell_timer(120)
		end
	end

	-- Rotation de la case libre
	while lcase.r ~= rNew do
		lcase.r = lcase.r + 1
		lcase.r = lcase.r - shell_mathfloor(lcase.r / 4) * 4
		refresh()
		shell_timer(120)
	end
end

-- Fonction qui permet de tracer tous les chemins  partir du player en cours
function pathFinder(p)
	local pTemp = _G["p"..p]
	-- Initialisation du tableau
	for n = 0, 48 do path[n] = "o" end
	path[pTemp.x + pTemp.y * 7] = 0	-- Start
	path[t.x + t.y * 7] = "x"	-- End
	-- Chemins possibles  partir du player
	local distance = 0
	local scanPath = 1
	while scanPath == 1 do
		scanPath = 0
		for i = 0, 6 do
			for j = 0, 6 do
				if path[i + j * 7] == distance then
					if j + 1 <= 6 then
						if type(path[i + (j + 1) * 7]) ~= "number" then
							if isCaseFree(i, j, 0, 1) == true then
								if caseLinker(i, j, 0, 1) == true then
									path[i + (j + 1) * 7] = distance + 1
									scanPath = 1
								end
							end
						end
					end
					if i + 1 <= 6 then
						if type(path[(i + 1) + j * 7]) ~= "number" then
							if isCaseFree(i, j, 1, 0) == true then
								if caseLinker(i, j, 1, 0) == true then
									path[(i + 1) + j * 7] = distance + 1 
									scanPath = 1
								end
							end
						end
					end
					if j - 1 >= 0 then
						if type(path[i + (j - 1) * 7]) ~= "number" then
							if isCaseFree(i, j, 0, -1) == true then
								if caseLinker(i, j, 0, -1) == true then
									path[i + (j - 1) * 7] = distance + 1 
									scanPath = 1
								end
							end
						end
					end
					if i - 1 >= 0 then
						if type(path[(i - 1) + j * 7]) ~= "number" then
							if isCaseFree(i, j, -1, 0) == true then
								if caseLinker(i, j, -1, 0) == true then
									path[(i - 1) + j * 7] = distance + 1 
									scanPath = 1
								end
							end
						end
					end
				end
			end
		end
		if scanPath == 1 then distance = distance + 1 end
	end
end


function cleanPath()
	local i = t.x
	local j = t.y
	local approach = -1
	local distance = 0
	local bestDistance = 100

	if type(path[i + j * 7]) == "number" then
		-- Le trsors est sur un des chemins
		distance = path[i + j * 7]
		approach = 0

	else
		-- Approach 1
		if i < 6 and j < 6 then
			if type(path[(i + 1) + (j + 1) * 7]) == "number" then
				approach = 1
				i = i + 1
				j = j + 1
				distance = path[i + j * 7]
			end
		end
		if approach < 1 and i > 0 and j < 6 then
			if type(path[(i - 1) + (j + 1) * 7]) == "number" then
				approach = 1
				i = i - 1
				j = j + 1
				distance = path[i + j * 7]
			end
		end
		if approach < 1 and i > 0 and j > 0 then
			if type(path[(i - 1) + (j - 1) * 7]) == "number" then
				approach = 1
				i = i - 1
				j = j - 1
				distance = path[i + j * 7]
			end
		end
		if approach < 1 and i < 6 and j > 0 then
			if type(path[(i + 1) + (j - 1) * 7]) == "number" then
				approach = 1
				i = i + 1
				j = j - 1
				distance = path[i + j * 7]
			end
		end

		-- approach 2
		if approach == -1 then
			if i < 5 then
				if type(path[(i + 2) + j * 7]) == "number" then
					approach = 2
					i = i + 2
					j = j
					distance = path[i + j * 7]
				end
			end
			if approach < 2 and j < 5 then
				if type(path[i + (j + 2) * 7]) == "number" then
					approach = 2
					i = i
					j = j + 2
					distance = path[i + j * 7]
				end
			end
			if approach < 2 and i > 1 then
				if type(path[(i - 2) + j * 7]) == "number" then
					approach = 2
					i = i - 2
					j = j
					distance = path[i + j * 7]
				end
			end
			if approach < 2 and j > 1 then
				if type(path[i + (j - 2) * 7]) == "number" then
					approach = 2
					i = i
					j = j - 2
					distance = path[i + j * 7]
				end
			end
		end

		-- Approach 3
		if approach == -1 then
			if i < 6 then
				if type(path[(i + 1) + j * 7]) == "number" then
					approach = 3
					i = i + 1
					j = j
					distance = path[i + j * 7]
				end
			end
			if approach < 3 and j < 6 then
				if type(path[i + (j + 1) * 7]) == "number" then
					approach = 3
					i = i
					j = j + 1
					distance = path[i + j * 7]
				end
			end
			if approach < 3 and i > 1 then
				if type(path[(i - 1) + j * 7]) == "number" then
					approach = 3
					i = i - 1
					j = j
					distance = path[i + j * 7]
				end
			end
			if approach < 3 and j > 1 then
				if type(path[i + (j - 1) * 7]) == "number" then
					approach = 3
					i = i
					j = j - 1
					distance = path[i + j * 7]
				end
			end
		end

		-- Au pire on teste avec la distance
		if approach == -1 then
			for ki = 0, 6 do
				for kj = 0, 6 do
					if type(path[ki + kj * 7]) == "number" then
						-- On value la distance la plus courte entre
						-- les cases de tous les chemins et le trsors
						local d = calculateDistance(ki, kj)
						if d < bestDistance then
							bestDistance = d
							distance = path[ki + kj * 7]
							i = ki
							j = kj
						end
					end
				end
			end
		end
	end

	-- Diffrenciation du chemin menant vers le trsors ou une case dfinie
	path[i + j * 7] = 1000 + distance
	for k = 1, distance do
		local scanPath = true
		if i < 6 and scanPath == true then
			if caseLinker(i, j, 1, 0) == true then
				if path[(i + 1) + j * 7] == distance - k then
					path[(i + 1) + j * 7] = 1000 + distance - k 
					i = i + 1
					scanPath = false
				end
			end
		end
		if j < 6 and scanPath == true then
			if caseLinker(i, j, 0, 1) == true then
				if path[i + (j + 1) * 7] == distance - k then
					path[i + (j + 1) * 7] = 1000 + distance - k 
					j = j + 1
					scanPath = false
				end
			end
		end
		if j > 0 and scanPath == true then
			if caseLinker(i, j, 0, -1) == true then
				if path[i + (j - 1) * 7] == distance - k then
					path[i + (j - 1) * 7] = 1000 + distance - k
					j = j - 1
					scanPath = false
				end
			end
		end       
		if i > 0 and scanPath == true then
			if caseLinker(i, j, -1, 0) == true then
				if path[(i - 1) + j * 7] == distance - k then
					path[(i - 1) + j * 7] = 1000 + distance - k
					i = i - 1
					scanPath = false
				end
			end
		end
	end
	
	-- Nettoyage du tableau path
	for n = 0, 48 do
		if type(path[n]) == "number" then
			if path[n] < 100 then path[n] = "o"
			else path[n] = path[n] - 1000
			end
		end
	end

	return approach, bestDistance
end

-- On suit le chemin
function followPath(p)
	local pTemp = _G["p"..p]
	local i = pTemp.x
	local j = pTemp.y
	local k = 1
	local scanPath = 0
	while scanPath == 0 do
		scanPath = 1
		if i < 6 and scanPath == 1 then
			if path[(i + 1) + j * 7] == k then
				i = i + 1
				movePlayer(p, 1, 0)
				refresh()
				shell_timer(120)
				scanPath = 0
			end
		end
		if j < 6 and scanPath == 1 then
			if path[i + (j + 1) * 7] == k then
				j = j + 1
				movePlayer(p, 0, 1)
				refresh()
				shell_timer(120)
				scanPath = 0
			end
		end
		if j > 0 and scanPath == 1 then
			if path[i + (j - 1) * 7] == k then
				j = j - 1
				movePlayer(p, 0, -1)
				refresh()
				shell_timer(120)
				scanPath = 0
			end
		end       
		if i > 0 and scanPath == 1 then
			if path[(i - 1) + j * 7] == k then
				i = i - 1
				movePlayer(p, -1, 0)
				refresh()
				shell_timer(120)
				scanPath = 0
			end
		end
		k = k + 1
	end
end

-- http://lua-users.org/wiki/CopyTable
function deepcopy(object)
    local lookup_table = {}
    local function _copy(object)
        if type(object) ~= "table" then
            return object
        elseif lookup_table[object] then
            return lookup_table[object]
        end
        local new_table = {}
        lookup_table[object] = new_table
        for index, value in pairs(object) do
            new_table[_copy(index)] = _copy(value)
        end
        return setmetatable(new_table, getmetatable(object))
    end
    return _copy(object)
end

-- Fonction pour scanner toutes les possibilites
function brain()

	-- sauvegarde de la map et positions des pions et coin
	local SAFEmap = deepcopy(map)
	local SAFEtx = t.x
	local SAFEty = t.y
	local SAFEp1x = p1.x
	local SAFEp1y = p1.y
	local SAFEp2x = p2.x
	local SAFEp2y = p2.y
	local SAFEp3x = p3.x
	local SAFEp3y = p3.y
	local SAFEp4x = p4.x
	local SAFEp4y = p4.y
	local SAFElcasex = lcase.x
	local SAFElcasey = lcase.y
	local SAFElcasei = lcase.i
	local SAFElcaser = lcase.r
	local SAFElcasexblock = lcase.xBlock
	local SAFElcaseyblock = lcase.yBlock

	local bestPath = -1

	local bestApproach = 10
	local bestDistance = 100

	for findPath = 0, 47 do -- 4 rotations * 12 cases

		lcase.x, lcase.y, lcase.r = convertPosition(findPath)

		if lcase.x == lcase.xBlock and lcase.y == lcase.yBlock then
			-- Pas de tests dans ce cas
		else
			slide()
			pathFinder(player)

			if bestApproach > 0 then

				local approach = -1
				local distance = 100

				approach, distance = cleanPath()

				if approach == 0 then
					-- Le trsors est l !
					bestApproach = 0
					bestPath = findPath
				elseif approach > 0 then
					if approach < bestApproach then
						bestApproach = approach
						bestPath = findPath
					end
				else
					if distance < bestDistance then
						bestDistance = distance
						bestPath = findPath
					end
				end
			end
	
			-- restoration des donnes
			map = deepcopy(SAFEmap)
			t.x = SAFEtx
			t.y = SAFEty
			p1.x = SAFEp1x 
			p1.y = SAFEp1y
			p2.x = SAFEp2x
			p2.y = SAFEp2y
			p3.x = SAFEp3x
			p3.y = SAFEp3y
			p4.x = SAFEp4x
			p4.y = SAFEp4y
			lcase.i = SAFElcasei
			lcase.xBlock = SAFElcasexblock
			lcase.yBlock = SAFElcaseyblock
		end

		-- restoration des donnes
		lcase.x = SAFElcasex
		lcase.y = SAFElcasey
		lcase.r = SAFElcaser
	end

	return bestPath
end


function convertPosition(p)
	local x = 0
	local y = 0
	local r = 0
	-- Insertion par le haut
	if	p == 0	then	x = 1	y = -1	r = 0
	elseif	p == 1	then	x = 1	y = -1	r = 1
	elseif	p == 2	then	x = 1	y = -1	r = 2
	elseif	p == 3	then	x = 1	y = -1	r = 3
	elseif	p == 4	then	x = 3	y = -1	r = 0
	elseif	p == 5	then	x = 3	y = -1	r = 1
	elseif	p == 6	then	x = 3	y = -1	r = 2
	elseif	p == 7	then	x = 3	y = -1	r = 3
	elseif	p == 8	then	x = 5	y = -1	r = 0
	elseif	p == 9	then	x = 5	y = -1	r = 1
	elseif	p == 10	then	x = 5	y = -1	r = 2
	elseif	p == 11	then	x = 5	y = -1	r = 3
	-- Insertion par la droite
	elseif	p == 12	then	x = 7	y = 1	r = 0
	elseif	p == 13	then	x = 7	y = 1	r = 1
	elseif	p == 14	then	x = 7	y = 1	r = 2
	elseif	p == 15	then	x = 7	y = 1	r = 3
	elseif	p == 16	then	x = 7	y = 3	r = 0
	elseif	p == 17	then	x = 7	y = 3	r = 1
	elseif	p == 18	then	x = 7	y = 3	r = 2
	elseif	p == 19	then	x = 7	y = 3	r = 3
	elseif	p == 20	then	x = 7	y = 5	r = 0
	elseif	p == 21	then	x = 7	y = 5	r = 1
	elseif	p == 22	then	x = 7	y = 5	r = 2
	elseif	p == 23	then	x = 7	y = 5	r = 3
	-- Insertion par le bas
	elseif	p == 24	then	x = 5	y = 7	r = 0
	elseif	p == 25	then	x = 5	y = 7	r = 1
	elseif	p == 26	then	x = 5	y = 7	r = 2
	elseif	p == 27	then	x = 5	y = 7	r = 3
	elseif	p == 28	then	x = 3	y = 7	r = 0
	elseif	p == 29	then	x = 3	y = 7	r = 1
	elseif	p == 30	then	x = 3	y = 7	r = 2
	elseif	p == 31	then	x = 3	y = 7	r = 3
	elseif	p == 32	then	x = 1	y = 7	r = 0
	elseif	p == 33	then	x = 1	y = 7	r = 1
	elseif	p == 34	then	x = 1	y = 7	r = 2
	elseif	p == 35	then	x = 1	y = 7	r = 3
	-- Insertion par la gauche
	elseif	p == 36	then	x = -1	y = 5	r = 0
	elseif	p == 37	then	x = -1	y = 5	r = 1
	elseif	p == 38	then	x = -1	y = 5	r = 2
	elseif	p == 39	then	x = -1	y = 5	r = 3
	elseif	p == 40	then	x = -1	y = 3	r = 0
	elseif	p == 41	then	x = -1	y = 3	r = 1
	elseif	p == 42	then	x = -1	y = 3	r = 2
	elseif	p == 43	then	x = -1	y = 3	r = 3
	elseif	p == 44	then	x = -1	y = 1	r = 0
	elseif	p == 45	then	x = -1	y = 1	r = 1
	elseif	p == 46	then	x = -1	y = 1	r = 2
	elseif	p == 47	then	x = -1	y = 1	r = 3
	end
	return x, y, r
end
