-- ==========================
-- Magic Maze - www.atien.net
-- Fonctions du labyrinthe
-- ==========================

-- Fonction de cration du niveau
function buildMap()

	-- Disposition des cases fixes (i=image, r=rotation)
	-- 4 virages c1
	map[0] = {i = 1, r = 0}
	map[6] = {i = 1, r = 1}
	map[42] = {i = 1, r = 3}
	map[48] = {i = 1, r = 2}
	-- 12 croisement c2
	map[2] = {i = 2, r = 0}
	map[4] = {i = 2, r = 0}
	map[14] = {i = 2, r = 3}
	map[16] = {i = 2, r = 3}
	map[18] = {i = 2, r = 0}
	map[20] = {i = 2, r = 1}
	map[28] = {i = 2, r = 3}
	map[30] = {i = 2, r = 2}
	map[32] = {i = 2, r = 1}
	map[34] = {i = 2, r = 1}
	map[44] = {i = 2, r = 2}
	map[46] = {i = 2, r = 2}

	-- Disposition des cases mobiles
	c0max = 13 -- Couloirs
	c1max = 15 -- Virages
	c2max = 6  -- Croisements
	for x = 1, 5, 2 do
		for y = 0, 6 do
			local case = map[x + y * 7]
			case.i = checkCase()
			case.r = proba(0, 3)
		end
	end
	for x = 0, 6, 2 do
		for y = 1, 5, 2 do
			local case = map[x + y * 7]
			case.i = checkCase()
			case.r = proba(0, 3)
		end
	end
	
	-- Case restante pour la case libre
	lcase.i = checkCase()
	lcase.r = proba(0, 3)
end


-- Fonction qui teste le nombre de cases restantes parmis les c0max, c1max et c2max
function checkCase()
	i = math.random(0, 2)
	cTemp = _G["c"..i.."max"]
	while cTemp == 0 do
		i = math.random(0, 2)
		cTemp = _G["c"..i.."max"]
	end
	_G["c"..i.."max"] = cTemp - 1
	return i
end


-- Fonction permettant de faire coulisser une ligne ou une colone en fonction de la position de la case libre
function slide()
	-- Dplacement d'une ligne vers la droite
	if lcase.x == -1 then
		local ii = map[6 + lcase.y * 7].i
		local rr = map[6 + lcase.y * 7].r
		for xx = 6, 1, -1 do
			map[xx + lcase.y * 7].i = map[xx - 1 + lcase.y * 7].i
			map[xx + lcase.y * 7].r = map[xx - 1 + lcase.y * 7].r
		end
		map[lcase.y * 7].i = lcase.i
		map[lcase.y * 7].r = lcase.r
		lcase.i = ii
		lcase.r = rr
		lcase.x = 7
		-- Dplacement des pions
		for ptemp = 1, playermax do
			local name = _G["p"..ptemp]
			if name.y == lcase.y then
				name.x = name.x + 1
				if name.x > 6 then name.x = 0 end
			end
		end
		-- Dplacement du trsor
		if t.y == lcase.y then
			t.x = t.x + 1
			if t.x > 6 then t.x = 0 end
		end

	-- Dplacement d'une ligne vers la gauche
	elseif lcase.x == 7 then
		local ii = map[lcase.y * 7].i
		local rr = map[lcase.y * 7].r
		for xx = 0, 5 do
			map[xx + lcase.y * 7].i = map[xx + 1 + lcase.y * 7].i
			map[xx + lcase.y * 7].r = map[xx + 1 + lcase.y * 7].r
		end
		map[6 + lcase.y * 7].i = lcase.i
		map[6 + lcase.y * 7].r = lcase.r
		lcase.i = ii
		lcase.r = rr
		lcase.x = -1
		-- Dplacement des pions
		for ptemp = 1, playermax do
			local name = _G["p"..ptemp]
			if name.y == lcase.y then
				name.x = name.x - 1
				if name.x < 0 then name.x = 6 end
			end
		end
		-- Dplacement du trsor
		if t.y == lcase.y then
			t.x = t.x - 1
			if t.x < 0 then t.x = 6 end
		end

	-- Dplacement d'une ligne vers le bas
	elseif lcase.y == -1 then
		local ii = map[lcase.x + 6 * 7].i
		local rr = map[lcase.x + 6 * 7].r
		for yy = 6, 1, -1 do
			map[lcase.x + yy * 7].i = map[lcase.x + (yy - 1) * 7].i
			map[lcase.x + yy * 7].r = map[lcase.x + (yy - 1) * 7].r
		end
		map[lcase.x].i = lcase.i
		map[lcase.x].r = lcase.r
		lcase.i = ii
		lcase.r = rr
		lcase.y = 7
		-- Dplacement des pions
		for ptemp = 1, playermax do
			local name = _G["p"..ptemp]
			if name.x == lcase.x then
				name.y = name.y + 1
				if name.y > 6 then name.y = 0 end
			end
		end
		-- Dplacement du trsor
		if t.x == lcase.x then
			t.y = t.y + 1
			if t.y > 6 then t.y = 0 end
		end

	-- Dplacement d'une ligne vers le haut
	elseif lcase.y == 7 then
		local ii = map[lcase.x].i
		local rr = map[lcase.x].r
		for yy = 0, 5 do
			map[lcase.x + yy * 7].i = map[lcase.x + (yy + 1) * 7].i
			map[lcase.x + yy * 7].r = map[lcase.x + (yy + 1) * 7].r
		end
		map[lcase.x + 6 * 7].i = lcase.i
		map[lcase.x + 6 * 7].r = lcase.r
		lcase.i = ii
		lcase.r = rr
		lcase.y = -1
		-- Dplacement des pions
		for ptemp = 1, playermax do
			local name = _G["p"..ptemp]
			if name.x == lcase.x then
				name.y = name.y - 1
				if name.y < 0 then name.y = 6 end
			end
		end
		-- Dplacement du trsor
		if t.x == lcase.x then
			t.y = t.y - 1
			if t.y < 0 then t.y = 6 end
		end
	end

	-- Rinitialisation de la case bloque
	lcase.xBlock = lcase.x
	lcase.yBlock = lcase.y
end


-- fonction de mouvement de la case libre
function moveCase(sens)
	if sens == 1 then -- sens des aiguilles d'une montre
		if lcase.y == -1 then
			lcase.x = lcase.x + 2
			if lcase.x == 7 then lcase.y = 1 end
		elseif lcase.x == 7 then
			lcase.y = lcase.y + 2
			if lcase.y == 7 then lcase.x = 5 end
		elseif lcase.y == 7 then
			lcase.x = lcase.x - 2
			if lcase.x == -1 then lcase.y = 5 end
		elseif lcase.x == -1 then
			lcase.y = lcase.y - 2
			if lcase.y == -1 then lcase.x = 1 end
		end
	elseif sens == -1 then -- sens inverse des aiguilles d'une montre
		if lcase.y == -1 then
			lcase.x = lcase.x - 2
			if lcase.x == -1 then lcase.y = 1 end
		elseif lcase.x == 7 then
			lcase.y = lcase.y - 2
			if lcase.y == -1 then lcase.x = 5 end
		elseif lcase.y == 7 then
			lcase.x = lcase.x + 2
			if lcase.x == 7 then lcase.y = 5 end
		elseif lcase.x == -1 then
			lcase.y = lcase.y + 2
			if lcase.y == 7 then lcase.x = 1 end
		end
	end
	refresh()
end


-- Fonctions pour tester si le lien entre les cases est ouvert ou ferm
function caseLinker(x, y, mx, my)
	local caseLinked = false
	local pos1 = x + y * 7
	local currentCase = 10 * map[pos1].i + map[pos1].r
	if mx == -1 and x > 0 then -- Test vers la gauche
		if currentCase ~= 1 and currentCase ~= 3 and currentCase ~= 10 and currentCase ~= 13 and currentCase ~= 23 then
			local pos2 = (x + mx) + (y + my) * 7
			local nextCase = 10 * map[pos2].i + map[pos2].r
			if nextCase ~= 1 and nextCase ~= 3 and nextCase ~= 11 and nextCase ~= 12 and nextCase ~= 21 then caseLinked = true end
		end
	elseif mx == 1 and x < 6 then -- Test vers la droite
		if currentCase ~= 1 and currentCase ~= 3 and currentCase ~= 11 and currentCase ~= 12 and currentCase ~= 21 then
			local pos2 = (x + mx) + (y + my) * 7
			local nextCase = 10 * map[pos2].i + map[pos2].r
			if nextCase ~= 1 and nextCase ~= 3 and nextCase ~= 10 and nextCase ~= 13 and nextCase ~= 23 then caseLinked = true end
		end
	elseif my == -1 and y > 0 then -- Test vers le haut
		if currentCase ~= 0 and currentCase ~= 2 and currentCase ~= 10 and currentCase ~= 11 and currentCase ~= 20 then
			local pos2 = (x + mx) + (y + my) * 7
			local nextCase = 10 * map[pos2].i + map[pos2].r
			if nextCase ~= 0 and nextCase ~= 2 and nextCase ~= 12 and nextCase ~= 13 and nextCase ~= 22 then caseLinked = true end
		end
	elseif my == 1 and y < 6 then -- Test vers le bas
		if currentCase ~= 0 and currentCase ~= 2 and currentCase ~= 12 and currentCase ~= 13 and currentCase ~= 22 then
			local pos2 = (x + mx) + (y + my) * 7
			local nextCase = 10 * map[pos2].i + map[pos2].r
			if nextCase ~= 0 and nextCase ~= 2 and nextCase ~= 10 and nextCase ~= 11 and nextCase ~= 20 then caseLinked = true end
		end
	end
	return caseLinked
end


-- Fonction pour tester si la case de destination est libre
function isCaseFree(x, y, mx, my)
	local caseEmpty = true
	for b = 1, playermax do
		if player ~= b then
			local bad = _G["p"..b]
			if (x + mx) == bad.x then
				if (y + my) == bad.y then
					caseEmpty = false
				end
			end
		end
	end
	return caseEmpty
end


-- Fonction pour le test de dplacement du player courant
function movePlayer(p, mx, my)
	local name = _G["p"..p]
	-- Teste si la case de destination est libre
	if isCaseFree(name.x, name.y, mx, my) == true then
		-- Teste le lien entre les deux cases
		if caseLinker(name.x, name.y, mx, my) == true then
			name.x = name.x + mx
			name.y = name.y + my
		end
	end
end

-- Fonction permettant de renvoyer la distance entre la case demande et coin
function calculateDistance(x, y)
	local dx = t.x - x
	local dy = t.y - y
	local d = shell_mathsqrt((dx * dx) + (dy * dy))
	return d
end
