-- ==========================
-- Magic Maze - www.atien.net
-- Fonctions d'affichage
-- ==========================

-- Fonction pour afficher l'cran en cours de partie
function refresh()

	local pTemp = _G["p"..player]

	shell_startdrawing()
	
	-- Affichage des flches
	shell_activate(dir)
	for y = 1, 5, 2 do shell_draw(dir, -1 * 30 + 41, y * 30 + 41, 8, 8, 0, 0, 8, 8) end
	for y = 1, 5, 2 do shell_draw(dir, 7 * 30 + 41, y * 30 + 41, 8, 8, 16, 0, 8, 8) end
	for x = 1, 5, 2 do shell_draw(dir, x * 30 + 41, -1 * 30 + 41, 8, 8, 8, 0, 8, 8) end
	for x = 1, 5, 2 do shell_draw(dir, x * 30 + 41, 7 * 30 + 41, 8, 8, 24, 0, 8, 8) end

	-- Gestion du dcalage lors d'un slide
	local slideX = 0
	local slideY = 0
	if lcase.x == -1 then		slideX = 1 * slideTime
	elseif lcase.x == 7 then	slideX = -1 * slideTime
	elseif lcase.y == -1 then	slideY = 1 * slideTime
	elseif lcase.y == 7 then	slideY = -1 * slideTime
	end

	-- Affichage des case du niveau
	shell_activate(ground)
	for x = 0, 6 do
		for y = 0, 6 do
			local case = map[x + y * 7]
			if lcase.x == x or lcase.y == y then
				shell_draw(ground, x * 30 + 30 + slideX, y * 30 + 30 + slideY, 30, 30, case.i * 30, 0, 30, 30, case.r)
			else
				shell_draw(ground, x * 30 + 30, y * 30 + 30, 30, 30, case.i * 30, 0, 30, 30, case.r)
			end
		end
	end
	
	-- Affichage de la case libre
	shell_draw(ground, lcase.x * 30 + 30 + slideX, lcase.y * 30 + 30 + slideY, 30, 30, lcase.i * 30, 0, 30, 30, lcase.r)

	-- Affichage du sight helper
	local color
	if player == 1 then color = green
	elseif player == 2 then color = yellow
	elseif player == 3 then color = blue
	elseif player == 4 then color = red
	end
	if lcase.x == pTemp.x or lcase.y == pTemp.y then
		shell_drawcircle(pTemp.x * 30 + 45 + slideX, pTemp.y * 30 + 45 + slideY, 26, 30, color)
	else
		shell_drawcircle(pTemp.x * 30 + 45, pTemp.y * 30 + 45, 26, 30, color)
	end

	-- Affichage du trsor
	shell_activate(chest)
	if lcase.x == t.x or lcase.y == t.y then
		shell_draw(chest, t.x * 30 + 37 + slideX, t.y * 30 + 37 + slideY)
	else
		shell_draw(chest, t.x * 30 + 37, t.y * 30 + 37)
	end
	
	-- Affichage des pions
	shell_activate(pion)
	for i = 1, 4 do
		local pTemp = _G["p"..i]
		if pTemp.select > 0 then
			if lcase.x == pTemp.x or lcase.y == pTemp.y then
				shell_draw(pion, pTemp.x * 30 + 37 + slideX, pTemp.y * 30 + 37 + slideY, 16, 16, 0, (i - 1) * 16, 16, 16)
			else
				shell_draw(pion, pTemp.x * 30 + 37, pTemp.y * 30 + 37, 16, 16, 0, (i - 1) * 16, 16, 16)
			end
		end
	end
	shell_draw(pion, 342, 12, 16, 16, 0, (player - 1) * 16, 16, 16)
	
	-- Affichage du sens interdit
	if lcase.xBlock ~= nil then
		shell_activate(noway)
		shell_draw(noway, lcase.xBlock * 30 + 37, lcase.yBlock * 30 + 37)
	end

	-- Affichage des infos
	shell_activate(verdana10)
	shell_print(verdana10, 360, 20, white, "Player: "..player)
	shell_print(verdana10, 360, 40, white, "Score: "..pTemp.score)
	if gameMode == 1 then
		shell_print(verdana10, 300, 60, white, "Move the flagstone.")
		shell_print(verdana10, 300, 70, white, "Cross to turn it.")
		shell_print(verdana10, 300, 80, white, "Circle to insert it.")
	else
		shell_print(verdana10, 300, 60, white, "Move your pawn.")
		shell_print(verdana10, 300, 70, white, "Circle when it's ok.")
	end
	
	if debug == true then
		if name.select == 2 and path[10] ~= nil then
			-- Affichage du Path AI
			for i = 0, 6 do
				for j = 0, 6 do
					shell_print(verdana10, i * 30 + 30, j * 30 + 30, white, path[i + j * 7])
				end
			end
		end
	end

	shell_enddrawing()
end
