-- ==========================
-- Magic Maze - www.atien.net
-- ==========================

version	= "0.2.6"
debug	= false

dofile("./data/lua/shell.lua")
dofile("./data/lua/maze.lua")
dofile("./data/lua/menu.lua")
dofile("./data/lua/computer.lua")
dofile("./data/lua/screen.lua")

ground = shell_loadGFX("./data/png/ground.png")
if not ground then error("Failed to load ground.png") end

dir = shell_loadGFX("./data/png/dir.png")
if not dir then error("Failed to load dir.png") end

pion = shell_loadGFX("./data/png/pion.png")
if not pion then error("Failed to load pion.png") end

chest = shell_loadGFX("./data/png/chest.png")
if not chest then error("Failed to load chest.png") end

noway = shell_loadGFX("./data/png/noway.png")
if not noway then error("Failed to load noway.png") end

title = shell_loadGFX("./data/png/title.png")
if not title then error("Failed to load title.png") end

verdana10 = shell_loadfont("./data/font/verdana.ttf", 10)
if not verdana10 then error("Failed to load vedrana.ttf") end
shell_fontsize(verdana10, 10)

-- Initialisation des tableaux map et path (7 lignes x 7 colonnes)
map = {}
for n = 0, 48 do map[n] = {i = nil, r = nil} end
path = {}
for n = 0, 48 do path[n] = "o" end

-- Initialisation des players  un endroit o ils ne gneront pas
p1 = {x = -1, y = -1, score = 0, select = 2}
p2 = {x = -1, y = -1, score = 0, select = 2}
p3 = {x = -1, y = -1, score = 0, select = 0}
p4 = {x = -1, y = -1, score = 0, select = 0}

-- Initialisation de la case libre a deplacer autour du tableau
-- xBlock, yBlock sont les coordonnes du sens interdit aprs insertion de la case libre
lcase = {x = 1, y = -1, xBlock = nil, yBlock = nil}

-- Initialisation de la position du trsor
t = {x = 3, y = 3}

gameMode	= 0	-- Mode de jeu (0 = menu, 1 = deplace case, 2 = deplace pion, 3 = fin de partie)
slideTime	= 0	-- Temps pour le slide
player		= 1	-- Joueur en cours
playermax	= 4	-- Nombre de joueurs max dans la partie
tmax		= 10	-- Nombre de trsors  ramasser
menu		= 1	-- Initialisation des menus

-- Couleurs
white	= shell_color(255, 255, 255)
black	= shell_color(0, 0, 0)
green	= shell_color(163, 206, 39)
yellow	= shell_color(249, 253, 54)
blue	= shell_color(159, 153, 230)
red	= shell_color(238, 0, 0)

-- Fonction pour tirer un chiffre au hasard entre a et b
function proba(a, b)
    math.randomseed(math.random(1, os.time()) / 100 * math.pi)
    math.random(); math.random(1, math.pi)
    return math.random(a, b)
end

-- Fonction permettant de voir si la position du player est la mme que celle du trsor
function checkScore(p)
	local name = _G["p"..p]
	if name.x == t.x and name.y == t.y then
		name.score = name.score - 1
		-- Test pour savoir si le joueur a gagn la partie
		if name.score == 0 then
			gameMode = 3
			return gameMode
		end
		-- Dplacement du trsor sur une case innocupe
		t = {x = proba(0, 6), y = proba(0, 6)}
		while t.x == p1.x or t.x == p2.x or t.x == p3.x or t.x == p4.x do t.x = proba(0, 6) end
		while t.y == p1.y or t.y == p2.y or t.y == p3.y or t.y == p4.y do t.y = proba(0, 6) end
	end
end

pad	= 0
oldpad	= 1

-- ========================
-- Programme principal
-- ========================
--while pge.running() do
while true do

	-- Lecture des controles (PGE ne return rien)
	pad = shell_controlsupdate()
	if pad == undefined then
		pad = oldpad + 1
		if pad > 5 then pad = 0 end
	end 

	-- Bouton start
	if shell_controlspress("start") then break end

	-- Mode menu
	if gameMode == 0 then
		drawMenu()
		if pad ~= oldpad then

			-- Croix directionelle haut
			if shell_controlspress("up") and menu > 1 then		menu = menu - 1
		
			-- Croix directionelle bas
			elseif shell_controlspress("down") and menu < 5 then	menu = menu + 1
		
			-- Croix directionelle gauche
			elseif shell_controlspress("left") then
				if menu == 1 and p1.select > 0 then		p1.select = p1.select - 1
				elseif menu == 2 and p2.select > 0 then		p2.select = p2.select - 1
				elseif menu == 3 and p3.select > 0 then		p3.select = p3.select - 1
				elseif menu == 4 and p4.select > 0 then		p4.select = p4.select - 1
				elseif menu == 5 and tmax > 1 then		tmax = tmax - 1
				end
		
			-- Croix directionelle droite
			elseif shell_controlspress("right") then
				if menu == 1 and p1.select < 2 then		p1.select = p1.select + 1
				elseif menu == 2 and p2.select < 2 then		p2.select = p2.select + 1
				elseif menu == 3 and p3.select < 2 then		p3.select = p3.select + 1
				elseif menu == 4 and p4.select < 2 then		p4.select = p4.select + 1
				elseif menu == 5 and tmax < 50 then		tmax = tmax + 1
				end
		
			-- Touche rond
			elseif shell_controlspress("circle") then
				-- Rien ne se passe si aucun joueur n'est valid pour jouer
				if p1.select ~= 0 or p2.select ~= 0 or p3.select ~= 0 or p4.select ~= 0 then
					-- Initialisation des pions (position x,y dans le tableau et score)
					if p1.select ~= 0 then
						p1.x = 0
						p1.y = 0
						p1.score = tmax
					end
					if p2.select ~= 0 then
						p2.x = 6
						p2.y = 6
						p2.score = tmax
					end
					if p3.select ~= 0 then
						p3.x = 6
						p3.y = 0
						p3.score = tmax
					end
					if p4.select ~= 0 then
						p4.x = 0
						p4.y = 6
						p4.score = tmax
					end
			
					gameMode = 1
			
					buildMap()
			
					player = proba(1, 4)
					local ptemp = _G["p"..player]
					while ptemp.select == 0 do
						player = proba(1, 4)
						ptemp = _G["p"..player]
					end
				end
			end
		end


	-- Mode dplacement de case
	elseif gameMode == 1 then
	
		refresh()
		local ptemp = _G["p"..player]
	
		if slideTime == 0 then
	
			if ptemp.select == 1 then -- Player
				
				if pad ~= oldpad then

					-- Croix directionelle gauche
					if shell_controlspress("left") then
						if lcase.x > 0 then
							if lcase.y < 3 then moveCase(-1)
							elseif lcase.y > 3 then moveCase(1)
							end
						end
				
					-- Croix directionelle droite
					elseif shell_controlspress("right") then
						if lcase.x < 7 then
							if lcase.y < 3 then moveCase(1)
							elseif lcase.y > 3 then moveCase(-1)
							end
						end
				
					-- Croix directionelle haut
					elseif shell_controlspress("up") then
						if lcase.y > 0 then
							if lcase.x < 3 then moveCase(1)
							elseif lcase.x > 3 then moveCase(-1)
							end
						end
				
					-- Croix directionelle bas
					elseif shell_controlspress("down") then
						if lcase.y < 7 then
							if lcase.x < 3 then moveCase(-1)
							elseif lcase.x > 3 then moveCase(1)
							end
						end
				
					-- Touche croix (rotation de la case libre dans le sens des aiguilles d'une montre)
					elseif shell_controlspress("cross") then
						lcase.r = lcase.r + 1
						lcase.r = lcase.r - shell_mathfloor(lcase.r / 4) * 4
				
					-- Touche carr (rotation de la case libre dans le sens inverse des aiguilles d'une montre)
					elseif shell_controlspress("square") then
						lcase.r = lcase.r - 1
						lcase.r = lcase.r - shell_mathfloor(lcase.r / 4) * 4
				
					-- Touche rond (insertion de la case libre)
					elseif shell_controlspress("circle") then
						if lcase.x == lcase.xBlock and lcase.y == lcase.yBlock then
						else	slideTime = 1	end
					end

				end
			
			elseif ptemp.select == 2 then -- AI
				AIcase()
				slideTime = 1
			end
	
		else
			slideTime = slideTime + 1
			if slideTime == 30 then
				slideTime = 0
				slide()
				gameMode = 2
			end
		end
	
	-- Mode dplacement de pion
	elseif gameMode == 2 then
		refresh()
		local pTemp = _G["p"..player]
		if pTemp.select == 1 then

			if pad ~= oldpad then

				-- Croix directionelle gauche
				if shell_controlspress("left") then
					movePlayer(player, -1, 0)
					checkScore(player)
		
				-- Croix directionelle droite
				elseif shell_controlspress("right") then
					movePlayer(player, 1, 0)
					checkScore(player)
		
				-- Croix directionelle bas
				elseif shell_controlspress("down") then
					movePlayer(player, 0, 1)
					checkScore(player)
		
				-- Croix directionelle haut
				elseif shell_controlspress("up") then
					movePlayer(player, 0, -1)
					checkScore(player)
		
				-- Touche rond (Placement du pion)
				elseif shell_controlspress("circle") then
					if gameMode ~= 3 then
						player = player + 1
						if player > playermax then player = 1 end
						local ptemp = _G["p"..player]
						while ptemp.select == 0 do
							player = player + 1
							if player > playermax then player = 1 end
							ptemp = _G["p"..player]
						end
						gameMode = 1
					end
				end
			end
		
		elseif pTemp.select == 2 then -- AI

			pathFinder(player)

			-- Il bouge tant qu'il trouve des chests
			while cleanPath() == 0 do
				followPath(player)
				checkScore(player)
				pathFinder(player)
			end

			-- Il bouge une derniere fois pour se rapprocher du chest
			followPath(player)

			if gameMode ~= 3 then
				player = player + 1
				if player > playermax then player = 1 end
				local ptemp = _G["p"..player]
				while ptemp.select == 0 do
					player = player + 1
					if player > playermax then player = 1 end
					ptemp = _G["p"..player]
				end
				gameMode = 1
			end
		end
	
	-- Mode fin de jeu
	elseif gameMode == 3 then
		drawEnd()
	end

	if pad ~= undefined and pad ~= -1 then oldpad = pad end
end

-- Libration de la mmoire
-- Font
verdana10 = nil
-- GFX
ground = nil
dir = nil
pion = nil
chest = nil
noway = nil
title = nil
